# Cloud native motion detection microservice

This software implements the motion detection portion
of well known [motion-project](https://motion-project.github.io/) as
a microservice. For the tiling counterpart see `camera-tiler` repository.

In a nutshell:
- It brings the MJPEG stream into the cluster
- Performs highly optimal JPEG DCT coefficient based motion detection
  without actually decoding the JPEG frame to a bitmap
- WIP: Writes events to MongoDB
- WIP: Uploads screenshots to S3
- Exposes endpoint for distributing MJPEG stream inside the cluster,
  eg by the `camera-tiler`
- Exposes endpoint for inspecting DCT blocks where motion has been detected

# Developing

Bundled `docker-compose.yml` brings up:

* [Minio](http://localhost:9001/buckets/camdetect/browse)
* [Mongoexpress](http://localhost:8081/db/default/eventlog)

To manually trigger event:

```
docker kill -sUSR1 camera-motion-detect_camdetect_1
```
